<template>
  <div>
    <div id="nav">
      <div class="header">
        <img class="logo" src="../assets/icon-left-font-monochrome-black.svg" />
      </div>
    </div>
    <div class="container">
      <h1 v-if="mode == 'login'">Se connecter</h1>
      <h1 v-else>Créer un compte</h1>

      <p v-if="mode == 'login'">Vous n'avez pas encore de compte ?</p>
      <p v-else>Vous avez déjà un compte ?</p>

      <a href="#" v-if="mode == 'login'" @click="switchToCreateAccount"
        >Créer un compte</a
      >
      <a href="#" v-else @click="switchToLogin">Connectez-vous</a>
    </div>

    <input
      v-if="mode == 'create'"
      class="prenom"
      type="text"
      name="firstname"
      v-model="firstname"
      placeholder="prénom"
    />
    <br />
    <input
      v-if="mode == 'create'"
      class="nom"
      type="text"
      name="lastname"
      v-model="lastname"
      placeholder="nom"
    />
    <br />
    <input
      class="email"
      type="email"
      name="email"
      v-model="email"
      placeholder="email"
    />
    <br />
    <input
      class="password"
      type="password"
      autocomplete="new-password"
      name="password"
      v-model="password"
      placeholder="mot de passe"
    />
    <br />
    <div class="error" v-html="error" />
    <br />
    <button v-if="mode == 'login'" @click="login">Se connecter</button>
    <button v-else @click="createAccount">Créer mon compte</button>
  </div>
</template>

<script>
import AuthenticationService from "@/services/AuthenticationService";
import axios from "axios";

export default {
  name: "Home",
  components: {},

  data() {
    return {
      mode: "login",
      lastname: "",
      firstname: "",
      email: "",
      password: "",
      error: null,
    };
  },

  mounted () {
      const token = localStorage.getItem('token')
      if (token !== null) {
        this.$store.dispatch("setToken", token);
        axios.defaults.headers.common["Authorization"] = token;
        this.$router.push("messages"); 
        }
      },

  methods: {
    switchToCreateAccount: function () {
      this.mode = "create";
    },

    switchToLogin: function () {
      this.mode = "login";
    },

    async createAccount() {
      try {
        const response = await AuthenticationService.register({
          firstname: this.firstname,
          lastname: this.lastname,
          email: this.email,
          password: this.password,
        });   
        const token = response.data.token;
        this.$store.dispatch("setToken", response.data.token);
        localStorage.setItem("token", token);
        localStorage.setItem("userId", response.data.id);
        localStorage.setItem("username", response.data.username);
        localStorage.setItem("userRole", response.data.userRole);
        axios.defaults.headers.common["Authorization"] = token;
        this.$router.push("messages");
      } catch (error) {
        this.error = error.response.data.error;
      }
    },

    async login() {
      try {
        const response = await AuthenticationService.login({
          email: this.email,
          password: this.password,
        });
        const token = response.data.token;
        this.$store.dispatch("setToken", response.data.token);
        localStorage.setItem("token", token);
        localStorage.setItem("username", response.data.username);
        localStorage.setItem("userId", response.data.userId);
        localStorage.setItem("userRole", response.data.userRole);
        axios.defaults.headers.common["Authorization"] = token;
        this.$router.push("messages");
      } catch (error) {
        this.error = error.response.data.error;
      }
    },
  },
};
</script>

<style scoped>
.header {
  width: 95%;
  background-color: #d7d7d7;
  display: flex;
  flex-direction: row;
  justify-content: space-between;
  align-items: center;
  padding: 20px;
  margin: 0 auto;
  border-radius: 10px;
}
.logo {
  width: 200px;
}
.container-header {
  margin-bottom: 40px;
}
h1 {
  color: #d1515a;
  margin-bottom: 30px;
}
input {
  border-radius: 10px;
  padding: 10px 20px;
}
.prenom {
  margin-top: 30px;
}
.email,
.prenom,
.nom {
  margin-bottom: 20px;
}
button {
  border-radius: 10px;
  padding: 10px 50px;
  font-size: 0.9rem;
  background-color: #091f43;
  color: white;
}
.error {
  color: red;
  margin-top: 20px;
}
</style>

